//-----------------------------------------------------------
// WAVEFLT2 
// Copyright (c) 1999-2002 Tomoya Tokairin
// LICENSE: GPL
//
// adaptive MDCT shrinkage filter  

//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
// in the experimental stage
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!


#include "filter.h"


double *SHF_Buffer[MAX_CHN]; // buffer (L-R)
double* SHF_OL_buffer[MAX_CHN];  // buffer for overlap of MDCT

DWORD SHF_dwBufferLength[MAX_CHN]; // length of buffer
DWORD SHF_dwBufferSize[MAX_CHN]; // byte,  size of data remained in buffer

double *SHF_Input = NULL;	// input to filter
double *SHF_Output = NULL;	// output from filter
double *SHF_Freq = NULL;	 
double *SHF_window = NULL;	 

//#define MIN_LATE  128    // ŏxꎞ
#define MIN_LATE  4    // ŏxꎞ
#define MAX_LATE  32   // őxꎞ
//#define MAX_LATE  192   // őxꎞ
#define CORR_LNG  32   // ȑւvZƂ̒
#define LNG_OF_MDCTDELAY (MAX_LATE+CORR_LNG)  // DCT W̒xobt@̒

double **SHF_corr[MAX_CHN]; // SHF_corr[ch][band][delay]
double **SHF_MDCTbuf[MAX_CHN]; // SHF_MDCTbuf[ch][time][band],  buffer of past MDCT coeffients 
DWORD SHF_dwMDCTpos[MAX_CHN]; // MDCT WxobtǍݒn_
double *SHF_threshold[MAX_CHN];	// SHF_threshold[ch][band],  current threshold
double *SHF_alpha[MAX_CHN];
double *SHF_release[MAX_CHN];
double *SHF_releasetime[MAX_CHN];
DWORD *SHF_dwDelayPoint[MAX_CHN];
DWORD SHF_dwRefleshTime[MAX_CHN];
DWORD *SHF_dwHoldTime[MAX_CHN];


//--------------------------------------------------------
// ADP MDCT shrinkage filter
DWORD SHRINK_MDCT(double* lpFilterBuf, // filter buffer
			DWORD dwPointsInBuf, // points
			DWORD dwCh			// channel
			){
	
	DWORD i,dwWritePos,dwReadPos,dwReadSize; 
	DWORD dwShLeng;
	DWORD dwMDCTpos,band,dwMaxDelay,delay,dwFoo;
	double dMaxCorr,dFoo,XX,SIGX,FABX,e,grad;


//	static DWORD dwTrain = 10;

	dwWritePos = 0;
	dwReadPos = 0;
	dwShLeng = SHF_dwBufferLength[dwCh];

	memset(SHF_Input,0,sizeof(double)*dwShLeng); 

	while(1){

		// when there are still some data in buffer
		if(SHF_dwBufferSize[dwCh]){

			// copy remained data to input buffer 
			//note: dwShLeng/2 <= SHF_dwBufferSize < dwShLeng
			memcpy(SHF_Input,SHF_Buffer[dwCh],sizeof(double)*SHF_dwBufferSize[dwCh]);

			// fill data from filter buffer
			dwReadSize = dwShLeng - SHF_dwBufferSize[dwCh];
			memcpy(SHF_Input+SHF_dwBufferSize[dwCh],lpFilterBuf+dwReadPos,sizeof(double)*dwReadSize);

			SHF_dwBufferSize[dwCh] = 0;
		}
		else
		{
			// copy data from back to front
			memcpy(SHF_Input,SHF_Input+dwShLeng/2,sizeof(double)*dwShLeng/2); 

			// fill data from filter buffer
			dwReadSize = dwShLeng/2;
			memcpy(SHF_Input+dwShLeng/2,lpFilterBuf+dwReadPos,sizeof(double)*dwReadSize); 

		}

		dwReadPos += dwReadSize;
		
		//-----------
		// MDCT
		memcpy(SHF_Output,SHF_Input,sizeof(double)*dwShLeng);
		for(i = 0 ; i < dwShLeng; i++) SHF_Output[i] *= SHF_window[i];
		MDCT_fast(SHF_Output,SHF_Freq,ID_MDCT_ADPMDCT,ID_FFT_ADPMDCT);

		//--------------------------------

		dwMDCTpos = SHF_dwMDCTpos[dwCh];
		memcpy(SHF_MDCTbuf[dwCh][dwMDCTpos],SHF_Freq,sizeof(double)*(dwShLeng/2));
		for(band= 0;band < dwShLeng/2 ;band++){

			DWORD dwWatch;
//				dwWatch = 120;
//				dwWatch = 350;
				dwWatch = 2000;

			// calculation of correration
				// ȑ֌vZ (bƂɍXV)
/*
			if(SHF_dwRefleshTime[dwCh] == 0){
				
				dMaxCorr = 0;
				for(delay=MIN_LATE; delay<MAX_LATE; delay++){
					
					dFoo = 0;
					for(i=0;i<CORR_LNG;i++){
						dFoo +=	SHF_Freq[band]
							*SHF_MDCTbuf[dwCh][((dwMDCTpos+LNG_OF_MDCTDELAY)-delay-i)%LNG_OF_MDCTDELAY][band];
					}
					
					if(dFoo > dMaxCorr){
						dwMaxDelay = delay;
						dMaxCorr = dFoo;
					}
				}
				
				SHF_dwDelayPoint[dwCh][band] =  dwMaxDelay;

				if(band == 100) fprintf(stderr,"%d\n",dwMaxDelay);
			}
/*/

			// ȑ֌vZ(eԂƂɍXV)
				dMaxCorr = 0;
			for(delay=MIN_LATE; delay<MAX_LATE; delay++){
				
				SHF_corr[dwCh][band][delay] -= 
								SHF_MDCTbuf[dwCh][((dwMDCTpos+LNG_OF_MDCTDELAY)-CORR_LNG)%LNG_OF_MDCTDELAY][band]
								*SHF_MDCTbuf[dwCh][((dwMDCTpos+LNG_OF_MDCTDELAY)-CORR_LNG-delay)%LNG_OF_MDCTDELAY][band];
				SHF_corr[dwCh][band][delay] += 
								SHF_MDCTbuf[dwCh][dwMDCTpos][band]
								*SHF_MDCTbuf[dwCh][((dwMDCTpos+LNG_OF_MDCTDELAY)-delay)%LNG_OF_MDCTDELAY][band];

				// search the time when correration between signals becomes max
				dFoo = SHF_corr[dwCh][band][delay];
				
					if(dFoo > dMaxCorr){
						dwMaxDelay = delay;
						dMaxCorr = dFoo;
					}

			}
			SHF_dwDelayPoint[dwCh][band] =  dwMaxDelay;
//*/

			// thresholding
			XX = SHF_Freq[band];
			SIGX = XX >=0 ? 1: -1;
			FABX = fabs(XX);
			
			// renew threshold value
			if(FABX > SHF_threshold[dwCh][band]){


				dwFoo = (LNG_OF_MDCTDELAY + dwMDCTpos - SHF_dwDelayPoint[dwCh][band])
					% LNG_OF_MDCTDELAY;

				e =  -1*SHF_MDCTbuf[dwCh][dwFoo][band] - SHF_Freq[band]; // error
//				grad = e * SIGX; 
				if(SHF_threshold[dwCh][band] == 0) SHF_threshold[dwCh][band] = 1./(65536./2.);
				grad = e * SIGX * SHF_threshold[dwCh][band]/FABX; 

				if(band == dwWatch && dwCh == 0){
					fprintf(stdout,"%lf ",grad);
					if(grad < 0) fprintf(stdout,"[] ");
					else fprintf(stdout,"   ");
				}
				
				SHF_threshold[dwCh][band] = 
					max(1./(65536./2.),
					SHF_threshold[dwCh][band] - SHF_alpha[dwCh][band] * grad);

				SHF_dwHoldTime[dwCh][band] = 0;

			}

			
			// 臒l菬臒l
			else if(FABX < SHF_threshold[dwCh][band])
			{
//				if(SHF_dwHoldTime[dwCh][band] == 0){
					if(band == dwWatch && dwCh == 0) fprintf(stdout,"* ");
					
					dFoo = SHF_release[dwCh][band];
					SHF_threshold[dwCh][band] = max(1./(65536./2.),SHF_threshold[dwCh][band] - dFoo);
					//				SHF_threshold[dwCh][band] = SHF_threshold[dwCh][band] - dFoo;
					
					//				SHF_threshold[dwCh][band] = FABX;
/*				}
				else{
					SHF_dwHoldTime[dwCh][band] --;
					if(band == dwWatch && dwCh == 0) fprintf(stdout,"hold ");
				}
*/				
			}


//			SHF_Freq[band] = SIGX * max(0,FABX - max(0,SHF_threshold[dwCh][band]));
			dFoo = max(0,SHF_threshold[dwCh][band]);
			SHF_Freq[band] = SIGX * max(0,FABX - dFoo*dFoo/FABX);


/*			if(band == dwWatch && dwCh == 0) 
				fprintf(stdout,"%lf %lf -> %lf\n",
				20*log10(fabs(SHF_threshold[dwCh][band])),
				20*log10(FABX),
				20*log10(fabs(SHF_Freq[band])));
*/
		
		}
		SHF_dwMDCTpos[dwCh] = (SHF_dwMDCTpos[dwCh]+1)%LNG_OF_MDCTDELAY;


		//--------------
		// IMDCT
		IMDCT_fast(SHF_Output,SHF_Freq,ID_MDCT_ADPMDCT,ID_FFT_ADPMDCT);
		for(i = 0 ; i < dwShLeng; i++) SHF_Output[i] *= SHF_window[i];

		// output
		for(i = 0 ; i < dwShLeng/2 ; i++) 
			lpFilterBuf[dwWritePos+i] = SHF_Output[i]
			+ SHF_OL_buffer[dwCh][i]; // over lap
		dwWritePos += (dwShLeng/2);

		if(SHF_dwRefleshTime[dwCh] == 0) SHF_dwRefleshTime[dwCh] = CORR_LNG;
		else  SHF_dwRefleshTime[dwCh]--;
	

		// copy data to overlap buffer 
		memcpy(SHF_OL_buffer[dwCh],SHF_Output+dwShLeng/2,sizeof(double)*dwShLeng/2);

		if(dwReadPos + dwShLeng/2 > dwPointsInBuf) break;
	}

	//-------------------------------
	// copy remained data to buffer

	memcpy(SHF_Buffer[dwCh],SHF_Input+dwShLeng/2,sizeof(double)*dwShLeng/2); 
	SHF_dwBufferSize[dwCh] = dwShLeng/2;
	
	for(i=0;i< dwPointsInBuf-dwReadPos;i++){
		SHF_Buffer[dwCh][dwShLeng/2+i] = lpFilterBuf[dwReadPos+i]; 
		SHF_dwBufferSize[dwCh]++; 
	}

	return dwWritePos;
}




//--------------------------------------------------------------------
// unprepare
void unprepareShrink(){

	DWORD i;
	
	for(i=0;i<	SHF_dwBufferLength[0]/2;i++){
		if(SHF_threshold[0][i] <= 0)
			fprintf(stdout,"%d   -200\n",(DWORD)((double)i/(SHF_dwBufferLength[0]/2)*4000.));
		else
			fprintf(stdout,"%d   %d\n",(DWORD)((double)i/(SHF_dwBufferLength[0]/2)*4000.),
			(DWORD)(SHF_threshold[0][i]*65536/2));
//			20*log10(fabs(SHF_threshold[0][i])));
	}

	if(SHF_Input) free(SHF_Input); 
	if(SHF_Output) free(SHF_Output); 
	if(SHF_Freq) free(SHF_Freq); 
	if(SHF_window) free(SHF_window); 

	SHF_Input = NULL;
	SHF_Output= NULL;
	SHF_Freq = NULL;
	SHF_window = NULL;

	for(i=0;i<MAX_CHN;i++){
		if(SHF_Buffer[i]) free(SHF_Buffer[i]); 
		if(SHF_OL_buffer[i]) free(SHF_OL_buffer[i]); 

		SHF_Buffer[i] = NULL;
		SHF_OL_buffer[i] = NULL;
		SHF_dwBufferSize[i] = 0;
	}


}




//----------------------------------------------------------------
// clear
void ClearShrink(){

	DWORD i;

	for(i=0;i<MAX_CHN;i++){
		if(SHF_Buffer[i]) memset(SHF_Buffer[i],0,sizeof(double)*SHF_dwBufferLength[i]);
		if(SHF_OL_buffer[i]) memset(SHF_OL_buffer[i],0,sizeof(double)*SHF_dwBufferLength[i]);
		SHF_dwBufferSize[i] = 0;
	}

}




//--------------------------------------------------------------------
// prepare
void prepareShrink(DWORD dwShLeng,
				   WAVEFORMATEX waveFmt,
				   double dThreshold  // dB
				   )
{
	DWORD i,i2;

//	dwShLeng = 2048;
	dwShLeng = 1024;
//	dwShLeng = 512;

	if(!SHF_Input) SHF_Input = (double*)malloc(sizeof(double)*dwShLeng +1024);
	if(!SHF_Output) SHF_Output= (double*)malloc(sizeof(double)*dwShLeng +1024);
	if(!SHF_Freq) SHF_Freq = (double*)malloc(sizeof(double)*dwShLeng +1024);
	if(!SHF_window) SHF_window = (double*)malloc(sizeof(double)*dwShLeng +1024);

	for(i=0;i<waveFmt.nChannels;i++){
		if(!SHF_Buffer[i]) SHF_Buffer[i] = (double*)malloc(sizeof(double)*dwShLeng +1024);
		if(!SHF_OL_buffer[i]) SHF_OL_buffer[i] = (double*)malloc(sizeof(double)*dwShLeng +1024);
		SHF_dwBufferLength[i] = dwShLeng;

		SHF_MDCTbuf[i] = (double**)malloc(sizeof(double*)*LNG_OF_MDCTDELAY);
		SHF_MDCTbuf[i][0] = (double*)malloc(sizeof(double)*LNG_OF_MDCTDELAY*(dwShLeng/2));
		for(i2=1;i2<LNG_OF_MDCTDELAY;i2++) SHF_MDCTbuf[i][i2] = SHF_MDCTbuf[i][0] + (dwShLeng/2)*i2;
		memset(SHF_MDCTbuf[i][0],0,sizeof(double)*LNG_OF_MDCTDELAY*(dwShLeng/2));
		
		SHF_corr[i] = (double**)malloc(sizeof(double*)*(dwShLeng/2));
		SHF_corr[i][0] = (double*)malloc(sizeof(double)*(dwShLeng/2)*MAX_LATE);
		for(i2=1;i2<(dwShLeng/2);i2++) SHF_corr[i][i2] = SHF_corr[i][0] + MAX_LATE*i2;
		memset(SHF_corr[i][0],0,sizeof(double)*(dwShLeng/2)*MAX_LATE);
		
		SHF_threshold[i] = (double*)malloc(sizeof(double)*(dwShLeng/2));
		memset(SHF_threshold[i],0,sizeof(double)*(dwShLeng/2));

		SHF_alpha[i] = (double*)malloc(sizeof(double)*(dwShLeng/2));

		// Cl
		for(i2=0;i2<(dwShLeng/2);i2++) SHF_alpha[i][i2] = 0.5 ;//* log(i2+1)/log((dwShLeng/2));
		for(i2=0;i2<(dwShLeng/2/2);i2++) SHF_alpha[i][i2] = 0.5 ;//* log(i2+1)/log((dwShLeng/2));
		for(i2=0;i2<(dwShLeng/2/5);i2++) SHF_alpha[i][i2] = 0.3 ;//* log(i2+1)/log((dwShLeng/2));

		for(i2=0;i2<(dwShLeng/2);i2++) SHF_alpha[i][i2] = 0.3 ;

		// 臒l߂߂̃[X^C
		SHF_release[i] = (double*)malloc(sizeof(double)*(dwShLeng/2));
		for(i2=0;i2<(dwShLeng/2);i2++)	
//			SHF_release[i][i2] = 1./(waveFmt.nSamplesPerSec/(dwShLeng/2)*3000/1000);
			SHF_release[i][i2] = 1./(waveFmt.nSamplesPerSec/(dwShLeng/2)*2); // 2b

		SHF_releasetime[i] = (double*)malloc(sizeof(double)*(dwShLeng/2));

		SHF_dwDelayPoint[i] = (DWORD*)malloc(sizeof(DWORD)*(dwShLeng/2));
		for(i2=0;i2<(dwShLeng/2);i2++) SHF_dwDelayPoint[i][i2] = MAX_LATE-1;

		SHF_dwHoldTime[i] = (DWORD*)malloc(sizeof(DWORD)*(dwShLeng/2));
		
	}

	KBDWin(SHF_window,dwShLeng,4.5);
	prepareMDCT(dwShLeng,ID_MDCT_ADPMDCT,ID_FFT_ADPMDCT);
	ClearShrink();
}



// EOF


#if 0
//-----------------------------------------------------------
// WAVEFLT2 
// Copyright (c) 1999-2002 Tomoya Tokairin
// LICENSE: GPL
//
// adaptive MDCT shrinkage filter  

#include "filter.h"


double *SHF_Buffer[MAX_CHN]; // buffer (L-R)
double* SHF_OL_buffer[MAX_CHN];  // buffer for overlap of MDCT

DWORD SHF_dwBufferLength[MAX_CHN]; // length of buffer
DWORD SHF_dwBufferSize[MAX_CHN]; // byte,  size of data remained in buffer

double *SHF_Input = NULL;	// input to filter
double *SHF_Output = NULL;	// output from filter
double *SHF_Freq = NULL;	 
double *SHF_window = NULL;	 


#define MIN_LATE  64    // ŏxꎞ
#define MAX_LATE  128   // őxꎞ
#define CORR_LNG  128   // ȑւvZƂ̒
#define LNG_OF_MDCTDELAY (MAX_LATE+CORR_LNG)  // DCT W̒xobt@̒

double **SHF_corr[MAX_CHN]; // SHF_corr[ch][band][delay]
double **SHF_MDCTbuf[MAX_CHN]; // SHF_MDCTbuf[ch][time][band],  buffer of past MDCT coeffients 
DWORD SHF_dwMDCTpos[MAX_CHN]; // MDCT WxobtǍݒn_
double *SHF_threshold[MAX_CHN];	// SHF_threshold[ch][band],  threshold
double *SHF_alpha[MAX_CHN];
double *SHF_release[MAX_CHN];
double *SHF_releasetime[MAX_CHN];
DWORD *SHF_dwDelayPoint[MAX_CHN];


//--------------------------------------------------------
// ADP MDCT shrinkage filter
DWORD SHRINK_MDCT(double* lpFilterBuf, // filter buffer
			DWORD dwPointsInBuf, // points
			DWORD dwCh			// channel
			){
	
	DWORD i,dwWritePos,dwReadPos,dwReadSize; 
	DWORD dwShLeng;
	DWORD dwMDCTpos,band,dwMaxDelay,delay,dwFoo;
	double dMaxCorr,dSign,dFoo,XX,SIGX,FABX,e,grad;

	dwWritePos = 0;
	dwReadPos = 0;
	dwShLeng = SHF_dwBufferLength[dwCh];

	memset(SHF_Input,0,sizeof(double)*dwShLeng); 

	while(1){

		// when there are still some data in buffer
		if(SHF_dwBufferSize[dwCh]){

			// copy remained data to input buffer 
			//note: dwShLeng/2 <= SHF_dwBufferSize < dwShLeng
			memcpy(SHF_Input,SHF_Buffer[dwCh],sizeof(double)*SHF_dwBufferSize[dwCh]);

			// fill data from filter buffer
			dwReadSize = dwShLeng - SHF_dwBufferSize[dwCh];
			memcpy(SHF_Input+SHF_dwBufferSize[dwCh],lpFilterBuf+dwReadPos,sizeof(double)*dwReadSize);

			SHF_dwBufferSize[dwCh] = 0;
		}
		else
		{
			// copy data from back to front
			memcpy(SHF_Input,SHF_Input+dwShLeng/2,sizeof(double)*dwShLeng/2); 

			// fill data from filter buffer
			dwReadSize = dwShLeng/2;
			memcpy(SHF_Input+dwShLeng/2,lpFilterBuf+dwReadPos,sizeof(double)*dwReadSize); 

		}

		dwReadPos += dwReadSize;
		
		//-----------
		// MDCT
		memcpy(SHF_Output,SHF_Input,sizeof(double)*dwShLeng);
		for(i = 0 ; i < dwShLeng; i++) SHF_Output[i] *= SHF_window[i];
		MDCT_fast(SHF_Output,SHF_Freq,ID_MDCT_ADPMDCT,ID_FFT_ADPMDCT);

		memcpy(SHF_MDCTbuf[dwCh][SHF_dwMDCTpos[dwCh]],SHF_Freq,sizeof(double)*(dwShLeng/2));

		dwMDCTpos = SHF_dwMDCTpos[dwCh];
		for(band= 0;band < dwShLeng/2 ;band++){

			dwMaxDelay = 0;
			dMaxCorr = 0;
			dSign = 1;

			// calculation of correration
			for(delay=MIN_LATE; delay<MAX_LATE; delay++){
				
				SHF_corr[dwCh][band][delay] -= 
								SHF_MDCTbuf[dwCh][((dwMDCTpos+LNG_OF_MDCTDELAY)-CORR_LNG)%LNG_OF_MDCTDELAY][band]
								*SHF_MDCTbuf[dwCh][((dwMDCTpos+LNG_OF_MDCTDELAY)-CORR_LNG-delay)%LNG_OF_MDCTDELAY][band];
				SHF_corr[dwCh][band][delay] += 
								SHF_MDCTbuf[dwCh][dwMDCTpos][band]
								*SHF_MDCTbuf[dwCh][((dwMDCTpos+LNG_OF_MDCTDELAY)-delay)%LNG_OF_MDCTDELAY][band];

				// search the time when correration between signals becomes max
				dFoo = SHF_corr[dwCh][band][delay];
				if(dFoo >= dMaxCorr){
					dwMaxDelay = delay;
					dMaxCorr = dFoo;
				}
			}

			if(SHF_dwDelayPoint[dwCh][band] > dwMaxDelay) SHF_dwDelayPoint[dwCh][band]--;
			else if(SHF_dwDelayPoint[dwCh][band] < dwMaxDelay) SHF_dwDelayPoint[dwCh][band]++;
			dwMaxDelay = SHF_dwDelayPoint[dwCh][band];

			//	if(dwMaxDelay != 127) fprintf(stderr,"%d %d\n",band,dwMaxDelay);
			
			// thresholding
			XX = SHF_Freq[band];
			SIGX = XX >=0 ? 1: -1;
			FABX = fabs(XX);
			SHF_Freq[band] = SIGX * max(0,FABX - SHF_threshold[dwCh][band]);
			
			// renew threshold value
			if(FABX > SHF_threshold[dwCh][band]){

				dwFoo = (LNG_OF_MDCTDELAY + dwMDCTpos - dwMaxDelay)%LNG_OF_MDCTDELAY;

//				dSign = SHF_corr[dwCh][band][dwMaxDelay] >=0 ? 1 : -1;
				dSign = 1;
				
				e =  -1*dSign*SHF_MDCTbuf[dwCh][dwFoo][band] - SHF_Freq[band]; // error
				grad = e * SIGX; 
				
				SHF_threshold[dwCh][band] = max(0,SHF_threshold[dwCh][band] - SHF_alpha[dwCh][band] * grad);

				SHF_releasetime[dwCh][band] = 0;
			}
			else
			{
				SHF_releasetime[dwCh][band]++;
				if(SHF_releasetime[dwCh][band]<1024)
					dFoo = log(SHF_releasetime[dwCh][band])/log(1024) * SHF_release[dwCh][band];
//				else 
					dFoo = SHF_release[dwCh][band];
				SHF_threshold[dwCh][band] = max(0,SHF_threshold[dwCh][band] - dFoo);
			}
		
		}
		SHF_dwMDCTpos[dwCh] = (SHF_dwMDCTpos[dwCh]+1)%LNG_OF_MDCTDELAY;


		//--------------
		// IMDCT
		IMDCT_fast(SHF_Output,SHF_Freq,ID_MDCT_ADPMDCT,ID_FFT_ADPMDCT);
		for(i = 0 ; i < dwShLeng; i++) SHF_Output[i] *= SHF_window[i];

		// output
		for(i = 0 ; i < dwShLeng/2 ; i++) 
			lpFilterBuf[dwWritePos+i] = SHF_Output[i]
			+ SHF_OL_buffer[dwCh][i]; // over lap
		dwWritePos += (dwShLeng/2);

		// copy data to overlap buffer 
		memcpy(SHF_OL_buffer[dwCh],SHF_Output+dwShLeng/2,sizeof(double)*dwShLeng/2);

		if(dwReadPos + dwShLeng/2 > dwPointsInBuf) break;
	}

	//-------------------------------
	// copy remained data to buffer

	memcpy(SHF_Buffer[dwCh],SHF_Input+dwShLeng/2,sizeof(double)*dwShLeng/2); 
	SHF_dwBufferSize[dwCh] = dwShLeng/2;
	
	for(i=0;i< dwPointsInBuf-dwReadPos;i++){
		SHF_Buffer[dwCh][dwShLeng/2+i] = lpFilterBuf[dwReadPos+i]; 
		SHF_dwBufferSize[dwCh]++; 
	}

	return dwWritePos;
}




//--------------------------------------------------------------------
// unprepare
void unprepareShrink(){

	DWORD i;
	
	for(i=0;i<	SHF_dwBufferLength[0]/2;i++){
		if(SHF_threshold[0][i] == 0)
			fprintf(stdout,"%d   -96\n",i);
		else
			fprintf(stdout,"%d   %.0lf\n",i,20*log10(SHF_threshold[0][i]));
	}

	if(SHF_Input) free(SHF_Input); 
	if(SHF_Output) free(SHF_Output); 
	if(SHF_Freq) free(SHF_Freq); 
	if(SHF_window) free(SHF_window); 

	SHF_Input = NULL;
	SHF_Output= NULL;
	SHF_Freq = NULL;
	SHF_window = NULL;

	for(i=0;i<MAX_CHN;i++){
		if(SHF_Buffer[i]) free(SHF_Buffer[i]); 
		if(SHF_OL_buffer[i]) free(SHF_OL_buffer[i]); 

		SHF_Buffer[i] = NULL;
		SHF_OL_buffer[i] = NULL;
		SHF_dwBufferSize[i] = 0;
	}


}




//----------------------------------------------------------------
// clear
void ClearShrink(){

	DWORD i;

	for(i=0;i<MAX_CHN;i++){
		if(SHF_Buffer[i]) memset(SHF_Buffer[i],0,sizeof(double)*SHF_dwBufferLength[i]);
		if(SHF_OL_buffer[i]) memset(SHF_OL_buffer[i],0,sizeof(double)*SHF_dwBufferLength[i]);
		SHF_dwBufferSize[i] = 0;
	}

}




//--------------------------------------------------------------------
// prepare
void prepareShrink(DWORD dwShLeng,
				   DWORD dwCh,
				   double dThreshold  // dB
				   )
{
	DWORD i,i2;


//	dwShLeng = 2048;
	dwShLeng = 512;

	if(!SHF_Input) SHF_Input = (double*)malloc(sizeof(double)*dwShLeng +1024);
	if(!SHF_Output) SHF_Output= (double*)malloc(sizeof(double)*dwShLeng +1024);
	if(!SHF_Freq) SHF_Freq = (double*)malloc(sizeof(double)*dwShLeng +1024);
	if(!SHF_window) SHF_window = (double*)malloc(sizeof(double)*dwShLeng +1024);

	for(i=0;i<dwCh;i++){
		if(!SHF_Buffer[i]) SHF_Buffer[i] = (double*)malloc(sizeof(double)*dwShLeng +1024);
		if(!SHF_OL_buffer[i]) SHF_OL_buffer[i] = (double*)malloc(sizeof(double)*dwShLeng +1024);
		SHF_dwBufferLength[i] = dwShLeng;

		SHF_MDCTbuf[i] = (double**)malloc(sizeof(double*)*LNG_OF_MDCTDELAY);
		SHF_MDCTbuf[i][0] = (double*)malloc(sizeof(double)*LNG_OF_MDCTDELAY*(dwShLeng/2));
		for(i2=1;i2<LNG_OF_MDCTDELAY;i2++) SHF_MDCTbuf[i][i2] = SHF_MDCTbuf[i][0] + (dwShLeng/2)*i2;
		memset(SHF_MDCTbuf[i][0],0,sizeof(double)*LNG_OF_MDCTDELAY*(dwShLeng/2));
		
		SHF_corr[i] = (double**)malloc(sizeof(double*)*(dwShLeng/2));
		SHF_corr[i][0] = (double*)malloc(sizeof(double)*(dwShLeng/2)*MAX_LATE);
		for(i2=1;i2<(dwShLeng/2);i2++) SHF_corr[i][i2] = SHF_corr[i][0] + MAX_LATE*i2;
		memset(SHF_corr[i][0],0,sizeof(double)*(dwShLeng/2)*MAX_LATE);
		
		SHF_threshold[i] = (double*)malloc(sizeof(double)*(dwShLeng/2));
		memset(SHF_threshold[i],0,sizeof(double)*(dwShLeng/2));

		SHF_alpha[i] = (double*)malloc(sizeof(double)*(dwShLeng/2));
/*
		for(i2=0;i2<(dwShLeng/2);i2++) SHF_alpha[i][i2] = 0.005;
		for(i2=0;i2<8;i2++) SHF_alpha[i][i2] = 0.00001;
*/

		for(i2=0;i2<(dwShLeng/2);i2++) SHF_alpha[i][i2] = 0.1;
		for(i2=0;i2<8;i2++) SHF_alpha[i][i2] = 0.0001;

		SHF_release[i] = (double*)malloc(sizeof(double)*(dwShLeng/2));
//		for(i2=0;i2<(dwShLeng/2);i2++) SHF_release[i][i2] = 1./(44100./(dwShLeng/2)*15000/1000);
		for(i2=0;i2<(dwShLeng/2);i2++) SHF_release[i][i2] = 1./(22050./(dwShLeng/2)*1000/1000);

		SHF_releasetime[i] = (double*)malloc(sizeof(double)*(dwShLeng/2));

		SHF_dwDelayPoint[i] = (DWORD*)malloc(sizeof(DWORD)*(dwShLeng/2));
		for(i2=0;i2<(dwShLeng/2);i2++) SHF_dwDelayPoint[i][i2] = MAX_LATE-1;
		
	}

	KBDWin(SHF_window,dwShLeng,4.5);
	prepareMDCT(dwShLeng,ID_MDCT_ADPMDCT,ID_FFT_ADPMDCT);
	ClearShrink();
}



// EOF
#endif
